//[mahjong-utils](../../index.md)/[mahjongutils.hora](index.md)

# Package-level declarations

## Types

| Name | Summary |
|---|---|
| [ChitoiHoraHandPattern](-chitoi-hora-hand-pattern/index.md) | [common]<br>@Serializable<br>@SerialName(value = &quot;ChitoiHoraHandPattern&quot;)<br>data class [ChitoiHoraHandPattern](-chitoi-hora-hand-pattern/index.md)(val pairs: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)&lt;[Tile](../mahjongutils.models/-tile/index.md)&gt;, val agari: [Tile](../mahjongutils.models/-tile/index.md), val tsumo: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val selfWind: [Wind](../mahjongutils.models/-wind/index.md)? = null, val roundWind: [Wind](../mahjongutils.models/-wind/index.md)? = null) : [HoraHandPattern](-hora-hand-pattern/index.md), [IChitoiHandPattern](../mahjongutils.models.hand/-i-chitoi-hand-pattern/index.md)<br>七对子的和牌手牌 |
| [Hora](-hora/index.md) | [common]<br>@Serializable<br>data class [Hora](-hora/index.md) : [HoraInfo](-hora-info/index.md)<br>和牌分析结果 |
| [HoraArgs](-hora-args/index.md) | [common]<br>@Serializable<br>data class [HoraArgs](-hora-args/index.md)<br>和牌分析参数 |
| [HoraArgsErrorInfo](-hora-args-error-info/index.md) | [common]<br>enum [HoraArgsErrorInfo](-hora-args-error-info/index.md) : [Enum](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-enum/index.html)&lt;[HoraArgsErrorInfo](-hora-args-error-info/index.md)&gt; , [ErrorInfo](../mahjongutils/-error-info/index.md) |
| [HoraArgsValidationException](-hora-args-validation-exception/index.md) | [common]<br>class [HoraArgsValidationException](-hora-args-validation-exception/index.md)(val args: [HoraArgs](-hora-args/index.md), val errors: [Collection](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-collection/index.html)&lt;[HoraArgsErrorInfo](-hora-args-error-info/index.md)&gt;) : [ValidationException](../mahjongutils/-validation-exception/index.md) |
| [HoraHandPattern](-hora-hand-pattern/index.md) | [common]<br>@Serializable<br>sealed interface [HoraHandPattern](-hora-hand-pattern/index.md) : [HoraInfo](-hora-info/index.md), [HandPattern](../mahjongutils.models.hand/-hand-pattern/index.md)<br>和牌手牌 |
| [HoraInfo](-hora-info/index.md) | [common]<br>interface [HoraInfo](-hora-info/index.md)<br>和牌信息 |
| [HoraOptions](-hora-options/index.md) | [common]<br>@Serializable<br>data class [HoraOptions](-hora-options/index.md)(val aotenjou: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val allowKuitan: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val hasRenpuuJyantouHu: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val hasKiriageMangan: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val hasKazoeYakuman: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val hasMultipleYakuman: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val hasComplexYakuman: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html))<br>和牌分析选项 |
| [KokushiHoraHandPattern](-kokushi-hora-hand-pattern/index.md) | [common]<br>@Serializable<br>@SerialName(value = &quot;KokushiHoraHandPattern&quot;)<br>data class [KokushiHoraHandPattern](-kokushi-hora-hand-pattern/index.md)(val repeated: [Tile](../mahjongutils.models/-tile/index.md), val agari: [Tile](../mahjongutils.models/-tile/index.md), val tsumo: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), val selfWind: [Wind](../mahjongutils.models/-wind/index.md)? = null, val roundWind: [Wind](../mahjongutils.models/-wind/index.md)? = null) : [HoraHandPattern](-hora-hand-pattern/index.md), [IKokushiHandPattern](../mahjongutils.models.hand/-i-kokushi-hand-pattern/index.md)<br>国士无双的和牌手牌 |
| [RegularHoraHandPattern](-regular-hora-hand-pattern/index.md) | [common]<br>@Serializable<br>@SerialName(value = &quot;RegularHoraHandPattern&quot;)<br>data class [RegularHoraHandPattern](-regular-hora-hand-pattern/index.md) : [HoraHandPattern](-hora-hand-pattern/index.md), [IRegularHandPattern](../mahjongutils.models.hand/-i-regular-hand-pattern/index.md)<br>标准形的和牌手牌 |

## Functions

| Name | Summary |
|---|---|
| [hora](hora.md) | [common]<br>fun [hora](hora.md)(args: [HoraArgs](-hora-args/index.md)): [Hora](-hora/index.md)<br>[common]<br>fun [hora](hora.md)(shantenResult: [CommonShantenResult](../mahjongutils.shanten/-common-shanten-result/index.md)&lt;*&gt;, agari: [Tile](../mahjongutils.models/-tile/index.md), tsumo: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), dora: [Int](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html) = DEFAULT_DORA, selfWind: [Wind](../mahjongutils.models/-wind/index.md)? = DEFAULT_SELF_WIND, roundWind: [Wind](../mahjongutils.models/-wind/index.md)? = DEFAULT_ROUND_WIND, extraYaku: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)&lt;[Yaku](../mahjongutils.yaku/-yaku/index.md)&gt; = DEFAULT_EXTRA_YAKU, options: [HoraOptions](-hora-options/index.md) = DEFAULT_OPTIONS): [Hora](-hora/index.md)<br>fun [hora](hora.md)(tiles: [List](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)&lt;[Tile](../mahjongutils.models/-tile/index.md)&gt;, furo: [List](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)&lt;[Furo](../mahjongutils.models/-furo/index.md)&gt; = DEFAULT_FURO, agari: [Tile](../mahjongutils.models/-tile/index.md), tsumo: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), dora: [Int](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html) = DEFAULT_DORA, selfWind: [Wind](../mahjongutils.models/-wind/index.md)? = DEFAULT_SELF_WIND, roundWind: [Wind](../mahjongutils.models/-wind/index.md)? = DEFAULT_ROUND_WIND, extraYaku: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)&lt;[Yaku](../mahjongutils.yaku/-yaku/index.md)&gt; = DEFAULT_EXTRA_YAKU, options: [HoraOptions](-hora-options/index.md) = DEFAULT_OPTIONS): [Hora](-hora/index.md)<br>和牌分析 |
| [throwOnValidationError](throw-on-validation-error.md) | [common]<br>fun [HoraArgs](-hora-args/index.md).[throwOnValidationError](throw-on-validation-error.md)() |
| [validate](validate.md) | [common]<br>fun [HoraArgs](-hora-args/index.md).[validate](validate.md)(): [Collection](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-collection/index.html)&lt;[HoraArgsErrorInfo](-hora-args-error-info/index.md)&gt; |
